//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "UCalculatorDemo.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmCalculatorDemo *frmCalculatorDemo;
//---------------------------------------------------------------------------

__fastcall TfrmCalculatorDemo::TfrmCalculatorDemo(TComponent* Owner)
    : TForm(Owner)
{
  // For the purposes of this demo we have three variables and three functions.
  FCalculator.InsertVariable("x");
  FCalculator.InsertVariable("y");
  FCalculator.InsertVariable("z");

  FCalculator.InsertFunction("f1");
  FCalculator.InsertFunction("f2");
  FCalculator.InsertFunction("f3");
}
//---------------------------------------------------------------------------

__fastcall TfrmCalculatorDemo::~TfrmCalculatorDemo()
{
}
//---------------------------------------------------------------------------

void __fastcall TfrmCalculatorDemo::btnCloseClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------

void __fastcall TfrmCalculatorDemo::edtExpression1Exit(TObject *Sender)
{
  TTokenError Error = FCalculator.GetFunction("f1")->SetString(edtExpression1->Text.c_str());
  if (Error == teNoError)
  {
    edtExpression1->Text = FCalculator.GetFunction("f1")->GetString().c_str();
    edtRPNVersion1->Text = FCalculator.GetFunction("f1")->GetRPNString().c_str();
  }
  SetMessage(edtMessage1, Error);
  edtXValueExit(this);
}
//---------------------------------------------------------------------------

void __fastcall TfrmCalculatorDemo::edtExpression2Exit(TObject *Sender)
{
  TTokenError Error = FCalculator.GetFunction("f2")->SetString(edtExpression2->Text.c_str());
  if (Error == teNoError)
  {
    edtExpression2->Text = FCalculator.GetFunction("f2")->GetString().c_str();
    edtRPNVersion2->Text = FCalculator.GetFunction("f2")->GetRPNString().c_str();
  }
  SetMessage(edtMessage2, Error);
  edtXValueExit(this);
}
//---------------------------------------------------------------------------

void __fastcall TfrmCalculatorDemo::edtExpression3Exit(TObject *Sender)
{
  TTokenError Error = FCalculator.GetFunction("f3")->SetString(edtExpression3->Text.c_str());
  if (Error == teNoError)
  {
    edtExpression3->Text = FCalculator.GetFunction("f3")->GetString().c_str();
    edtRPNVersion3->Text = FCalculator.GetFunction("f3")->GetRPNString().c_str();
  }
  SetMessage(edtMessage3, Error);
  edtXValueExit(this);
}
//---------------------------------------------------------------------------

void __fastcall TfrmCalculatorDemo::edtXValueExit(TObject *Sender)
{
  FCalculator.GetVariable("x")->SetValue(StrToFloat(edtXValue->Text));
  FCalculator.GetVariable("y")->SetValue(StrToFloat(edtYValue->Text));
  FCalculator.GetVariable("z")->SetValue(StrToFloat(edtZValue->Text));

  if (FCalculator.GetFunction("f1")->GetCircular() == false)
  {
    double Result = FCalculator.GetFunction("f1")->GetValue();
    edtResult1->Text = FloatToStr(Result);
  }
  else
    edtResult1->Text = "";
  SetMessage(edtMessage1, FCalculator.GetFunction("f1")->GetError());

  if (FCalculator.GetFunction("f2")->GetCircular() == false)
  {
    double Result = FCalculator.GetFunction("f2")->GetValue();
    edtResult2->Text = FloatToStr(Result);
  }
  else
    edtResult2->Text = "";
  SetMessage(edtMessage2, FCalculator.GetFunction("f2")->GetError());

  if (FCalculator.GetFunction("f3")->GetCircular() == false)
  {
    double Result = FCalculator.GetFunction("f3")->GetValue();
    edtResult3->Text = FloatToStr(Result);
  }
  else
    edtResult3->Text = "";
  SetMessage(edtMessage3, FCalculator.GetFunction("f3")->GetError());
}
//---------------------------------------------------------------------------

void _fastcall TfrmCalculatorDemo::SetMessage(TEdit* AEdit, TTokenError Error)
{
  switch (Error)
  {
    case teNoError:
      AEdit->Text = "teNoError";
      break;
    case teIllegalToken:
      AEdit->Text = "teIllegalToken";
      break;
    case teBadParentheses:
      AEdit->Text = "teBadParentheses";
      break;
    case teBadSequence:
      AEdit->Text = "teBadSequence";
      break;
    case teMemoryAllocation:
      AEdit->Text = "teMemoryAllocation";
      break;
    case teCircularReference:
      AEdit->Text = "teCircularReference";
      break;
    case teNoTokens:
      AEdit->Text = "teNoTokens";
      break;
    case teExceptionOccurred:
      AEdit->Text = "teExceptionOccurred";
      break;
    case teInvalidNumber:
      AEdit->Text = "teInvalidNumber";
  }
}
//---------------------------------------------------------------------------

void __fastcall TfrmCalculatorDemo::edtExpression1KeyDown(TObject *Sender,
      WORD &Key, TShiftState Shift)
{
  if (Key == VK_RETURN)
    edtExpression1Exit(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TfrmCalculatorDemo::edtExpression2KeyDown(TObject *Sender,
      WORD &Key, TShiftState Shift)
{
  if (Key == VK_RETURN)
    edtExpression2Exit(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TfrmCalculatorDemo::edtExpression3KeyDown(TObject *Sender,
      WORD &Key, TShiftState Shift)
{
  if (Key == VK_RETURN)
    edtExpression3Exit(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TfrmCalculatorDemo::edtXValueKeyDown(TObject *Sender,
      WORD &Key, TShiftState Shift)
{
  if (Key == VK_RETURN)
    edtXValueExit(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TfrmCalculatorDemo::Button1Click(TObject *Sender)
{
  TVariable* VarX  = FCalculator.GetVariable("x");
  TVariable* VarY  = FCalculator.GetVariable("y");
  TFunction* Func1 = FCalculator.GetFunction("f1");

  int Ticks = GetTickCount();

  for (int X = 0; X < 1000; X++)
  {
    VarX->SetValue(X);
    for (int Y = 0; Y < 1000; Y++)
    {
      VarY->SetValue(Y);
      long double F = Func1->GetValue();
    }
  }

  Edit1->Text = IntToStr(GetTickCount() - Ticks);
}
//---------------------------------------------------------------------------

